extends Node

enum Class_type {
	Spectator = 0,
	Astra = 1,
	BlackArch = 2,
	Kali = 3,
	Debian = 4,
	Arch = 5,
	Windows11 = -1,
	WindowsServer = -2,
	MacOS = -3,
	WindowsXP = -4,
	Windows10 = -5
}

var Distro = {
	HP = 100,
	AP = 100,
	HACK = 1.0,
	class_type = 0,
}
var Player = {
	distro = Distro.duplicate(),
	speed = 1.0,
	position = Vector3(0, 10, 0),
	velocity = Vector3.ZERO,
	internal_id = 0,
}

const player_class := preload("res://scripts/PlayerClass.gd")

var player_model = preload("res://models/player.tscn")
var peer = ENetMultiplayerPeer.new()
var settings
var clients = {}

func _ready():
	if "--server" in OS.get_cmdline_args():
		await get_tree().create_timer(0.01).timeout #костыль пиздец но мне похую как-то
		get_tree().change_scene_to_file("res://scenes/test_map.tscn")
		StartServer()

#######################################SERVER####################################
func StartServer():
	settings = GameData.server_settings
	var port = int(settings["port"])
	var maxclients = int(settings["maxclients"])
	if (peer.create_server(port, maxclients) != OK):
		print("Couldn't create server. Check if another proccess binds port " + str(port))
		return
	
	multiplayer.multiplayer_peer = peer
	print("Server started")
	
	peer.connect("peer_connected", _Peer_Connected)
	peer.connect("peer_disconnected", _Peer_Disconnected)

func send_everyone_except(client_id, args):
	for current_client_id in clients.keys():
		if (str(current_client_id) == str(client_id)): continue
		if (args[1] == null): args[0].rpc_id(int(current_client_id))
		elif (args[2] == null): args[0].rpc_id(int(current_client_id), args[1])
		else: args[0].rpc_id(int(current_client_id), args[1], args[2])

func _Peer_Connected(client_id):
	var puppet = player_model.instantiate()
	var internal_id = clients.size() + 2
	puppet.find_child("CharacterBody3D").set_is_playable(false)
	puppet.find_child("CharacterBody3D").set_internal_id(internal_id)
	puppet.name = "player" + str(internal_id)
	
	clients[str(client_id)] = Player.duplicate()
	clients[str(client_id)]["internal_id"] = internal_id
	
	add_child(puppet)
	
	for current_client_id in clients.keys():
		if (int(current_client_id) == int(client_id)): continue
		rpc_id(int(current_client_id), "spawn_puppet", internal_id)
	
func _Peer_Disconnected(client_id):
	clients.erase(str(client_id))

@rpc ("any_peer", "reliable", "call_remote")
func get_character_properties(client_id):
	if !clients.has(str(client_id)):
		return
	var to_send = clients[str(client_id)]
	rpc_id(client_id, "set_character_properties", to_send)
	
@rpc("any_peer", "call_remote")
func move_client(client_id, position):
	#if(settings["enableAntiCheat"]): if(position > 10): return # нормально допилить надо
	clients[str(client_id)]["position"] = position
	var client = clients[str(client_id)]
	send_everyone_except(client_id, [get_node("player" + str(client["internal_id"])).find_child("CharacterBody3D").move_puppet, position, client["internal_id"]])

@rpc ("any_peer", "call_remote", "reliable")
func get_client_list(client_id):
	for current_client_id in clients.keys():
		if (current_client_id == str(client_id)): continue
		rpc_id(client_id, "spawn_puppet", clients[str(current_client_id)]["internal_id"])

##########################################CLIENT#######################

var player

@rpc ("reliable", "call_remote")
func set_character_properties(p):
	player = p

@rpc("authority", "reliable", "call_remote")
func spawn_puppet(internal_id):
	var puppet = player_model.instantiate()
	puppet.find_child("CharacterBody3D").set_is_playable(false)
	puppet.find_child("CharacterBody3D").set_internal_id(internal_id)
	puppet.name = "player" + str(internal_id)
	
	add_child(puppet)

func ConnectToServer(ip, port):
	peer.create_client(ip, port)
	multiplayer.multiplayer_peer = peer
	
	if not multiplayer.connected_to_server.is_connected(_Connection_Succseeded): 
		multiplayer.connected_to_server.connect(_Connection_Succseeded)
	if not multiplayer.connection_failed.is_connected(_Connection_Failed): 
		multiplayer.connection_failed.connect(_Connection_Failed)
	if not multiplayer.server_disconnected.is_connected(_Server_Disconnected):
		multiplayer.server_disconnected.connect(_Server_Disconnected)

func _Connection_Failed():
	print("Failed to connect to server")
	peer = ENetMultiplayerPeer.new()
	multiplayer.multiplayer_peer = null
	
func _Connection_Succseeded():
	print("Succsessfully connected to the server")
	
	rpc_id(1, "get_character_properties", multiplayer.get_unique_id())
	rpc_id(1, "get_client_list", multiplayer.get_unique_id())
	await get_tree().create_timer(0.2).timeout # костыль
	
	get_tree().change_scene_to_file("res://scenes/test_map.tscn")
	
	var player_node = player_model.instantiate()
	player_node.find_child("CharacterBody3D").set_is_playable(true)
	player_node.find_child("CharacterBody3D").set_internal_id(player["internal_id"])
	add_child(player_node)
	
func _Server_Disconnected():
	print("Server has disconnected")
